#include "..\script_component.hpp"

/*
 * Author: Creedcoder, J. Schmidt
 * Registers an AI unit as a hostage/POW.
 *
 * Arguments:
 * 0: The AI unit <OBJECT>
 * 1: ID of the task <STRING>
 *
 * Return Value:
 * None
 *
 * Example:
 * [this, "task_name"] spawn forge_client_task_fnc_makeHostage;
 *
 * Public: Yes
 */

params [["_entity", nil, [objNull, 0, [], sideUnknown, grpNull, ""]], ["_taskID", "", [""]]];

diag_log format ["[FORGE] Make Hostage: %1", _this];

SETVAR(_entity,assignedTask,_taskID);
GVAR(allHostages) pushBackUnique _entity;

if (alive _entity) then {
	[_entity, "hostage"] spawn FUNC(heartBeat);
};