#include "..\script_component.hpp"

/*
 * Author: Creedcoder, J. Schmidt
 * Registers an AI unit as a shooter/POW.
 *
 * Arguments:
 * 0: The AI unit <OBJECT>
 * 1: ID of the task <STRING>
 *
 * Return Value:
 * None
 *
 * Example:
 * [this, "task_name"] spawn forge_client_task_fnc_makeShooter;
 *
 * Public: Yes
 */

params [["_entity", nil, [objNull, 0, [], sideUnknown, grpNull, ""]], ["_taskID", "", [""]]];

diag_log format ["[FORGE] Make Shooter: %1", _this];

SETVAR(_entity,assignedTask,_taskID);
GVAR(allShooters) pushBackUnique _entity;